[状压dp] 洛谷 P1879 玉米田

题目描述

Farmer John has purchased a lush new rectangular pasture composed of M by N (1 ≤ M ≤ 12; 1 ≤ N ≤ 12) square parcels. He wants to grow some yummy corn for the cows on a number of squares. Regrettably, some of the squares are infertile and can't be planted. Canny FJ knows that the cows dislike eating close to each other, so when choosing which squares to plant, he avoids choosing squares that are adjacent; no two chosen squares share an edge. He has not yet made the final choice as to which squares to plant.

Being a very open-minded man, Farmer John wants to consider all possible options for how to choose the squares for planting. He is so open-minded that he considers choosing no squares as a valid option! Please help Farmer John determine the number of ways he can choose the squares to plant.

农场主John新买了一块长方形的新牧场,这块牧场被划分成M行N列(1 ≤ M ≤ 12; 1 ≤ N ≤ 12),每一格都是一块正方形的土地。John打算在牧场上的某几格里种上美味的草,供他的奶牛们享用。

遗憾的是,有些土地相当贫瘠,不能用来种草。并且,奶牛们喜欢独占一块草地的感觉,于是John不会选择两块相邻的土地,也就是说,没有哪两块草地有公共边。

John想知道,如果不考虑草地的总块数,那么,一共有多少种种植方案可供他选择?(当然,把新牧场完全荒废也是一种方案)

输入输出格式

输入格式:

 

第一行:两个整数M和N,用空格隔开。

第2到第M+1行:每行包含N个用空格隔开的整数,描述了每块土地的状态。第i+1行描述了第i行的土地,所有整数均为0或1,是1的话,表示这块土地足够肥沃,0则表示这块土地不适合种草。

 

输出格式:

 

一个整数,即牧场分配总方案数除以100,000,000的余数。

 

输入输出样例

输入样例#1:
2 3
1 1 1
0 1 0
输出样例#1:
9

 

 

题解

  • 这个数据范围很优秀,显然状压
  • 设f[i][j]为做到第i行的状态为j的方案数
  • 首先要预处理出,一个状态是否满足题目要求,一行内相邻两个不能都选
  • 那么就可以dp了
  • 状压dp一般的都是枚举行数,然后枚举两个状态,在这题就是当前第i行的状态和第i-1行的状态
  • 然后要判断两行and起来等于0
  • 状态转移方程显然  f[i][j]=(f[i][j]+f[i-1][k])%mo

代码

 1 #include <cstdio>
 2 #include <iostream>
 3 #include <cstring>
 4 using namespace std;
 5 const int mo=1e8;
 6 int n,m,a[20][20],g[20],l[1<<20],f[20][1<<20];
 7 int main()
 8 {
 9     scanf("%d%d",&n,&m);
10     for (int i=1;i<=n;i++)
11         for (int j=1;j<=m;j++)
12             scanf("%d",&a[i][j]),g[i]=(g[i]<<1)+a[i][j];
13     for (int i=0;i<(1<<m);i++) l[i]=(!(i&(i<<1)))&&(!(i&(i>>1)));
14     f[0][0]=1;
15     for (int i=1;i<=n;i++)
16         for (int j=0;j<(1<<m);j++)
17             if (l[j]&&((j&g[i])==j))
18                 for (int k=0;k<(1<<m);k++)
19                     if ((k&j)==0) f[i][j]=(f[i][j]+f[i-1][k])%mo;
20     int ans=0;
21     for (int i=0;i<(1<<m);i++) (ans+=f[n][i])%=mo;
22     printf("%d",ans);
23 }

 

posted @ 2018-10-15 10:24  BEYang_Z  阅读(300)  评论(0编辑  收藏  举报